﻿Imports System.ComponentModel
Imports System.Globalization
Imports System.IO
Imports System.Linq
Imports System.Text
Imports System.Windows
Imports System.Windows.Controls
Imports Telerik.Windows.Controls
Imports Telerik.Windows.Controls.Charting
Imports Telerik.Windows.Controls.DragDrop
Imports System.Collections.ObjectModel
Imports System.Windows.Media.Effects

Class MainWindow

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        Dim series As New DataSeries()
        series.Add(New DataPoint(20))
        series.Add(New DataPoint(30))
        series.Add(New DataPoint(40))
        series.Add(New DataPoint(80))
        series.Add(New DataPoint(10))
        series.Add(New DataPoint(50))
        series.Add(New DataPoint(40))
        series.Add(New DataPoint(20))
        series.Add(New DataPoint(90))

        series.Definition = New LineSeriesDefinition()
        series.Definition.Appearance.PointMark.Shape = MarkerShape.Diamond 

        RadChart.DefaultView.ChartArea.DataSeries.Add(series)
        AddHandler RadChart.DefaultView.ChartArea.ItemClick, AddressOf Me.RadChart_ChartItemClick

    End Sub

    Private Sub RadChart_ChartItemClick(ByVal sender As Object, ByVal e As ChartItemClickEventArgs)
        Try
            ClearPointMarkSelectedState()
            Dim pointMarks As List(Of PointMark) = RadChart.DefaultView.ChartArea.ChildrenOfType(Of PointMark)().ToList()
            _manualSelectedPointMark = pointMarks.Where(Function(x) x.DataContext.Equals(e.DataPoint)).SingleOrDefault()
            SetPointMarkSelectedState()
        Catch ex As Exception
            Debug.Print(ex.ToString)
        End Try
    End Sub

    Private _manualPointMarkFill As Brush
    Private _manualSelectedPointMark As PointMark

    Private Sub SetPointMarkSelectedState()

        If _manualSelectedPointMark IsNot Nothing Then
            _manualPointMarkFill = _manualSelectedPointMark.ChildrenOfType(Of System.Windows.Shapes.Path)().FirstOrDefault().Fill
            _manualSelectedPointMark.Fill = New SolidColorBrush(Colors.Black)
        End If
    End Sub

    Private Sub ClearPointMarkSelectedState()
        If _manualSelectedPointMark IsNot Nothing Then
            'The Color of the PointMark do not reset to white, the PointMark remains black.
            _manualSelectedPointMark.Fill = _manualPointMarkFill

            'That works, but is only correct if the PointMark was white before.
            '_manualSelectedPointMark.Fill = Brushes.White

            _manualSelectedPointMark = Nothing
        End If
    End Sub

End Class
